unit Unit1;

interface

uses
  ComObj, ActiveX, AspTlb, AKRipAX_TLB, StdVcl, SysUtils, AKRip32;

type
  TAKRip = class(TASPMTSObject, IAKRip)
  protected
    function Get_GetNumAdaptrers: Integer; safecall;
    function Get_GetAspiLibAspiError: Integer; safecall;
    function Get_GetAspiLibError: Integer; safecall;
    function Get_GetAKRipDLLVersion: Integer; safecall;
    function GetCDId(hCD: Integer; out strCDId: WideString): Integer; safecall;
    function GetCDList: Integer; safecall;
    function Get_GetCDListCount: Integer; safecall;
    procedure GetCDListRecord(var lngCDNum: Integer; out lngHA, lngTGT, lngLUN,
      lngPAD: Integer; out strID: WideString); safecall;
    procedure GetCDListInfo(lngCDNum: Integer; out strVendor, strProductID,
      strRevision, strVendorSpec: WideString); safecall;
    function GetCDHandle(lngVersion, lngHA, lngTGT, lngLUN,
      lngReadType: Integer; blnJitterCorrection: WordBool; lngNumJitter,
      lngNumOverlap: Integer): Integer; safecall;
    function CloseCDHandle(hCD: Integer): WordBool; safecall;
    function GetDriveInfo(lngHA, lngTGT, lngLUN: Integer): Integer; safecall;
    procedure GetDriveInfoInfo(out strVendor, strProductID, strRevision,
      strVendorSpec: WideString); safecall;
    procedure GetDriveInfoRecord(out lngHA, lngTGT, lngLUN, lngPAD: Integer;
      out strID: WideString); safecall;
    function ReadTOC(hCD: Integer): Integer; safecall;
    function Get_ReadTOCFirstTrack: Integer; safecall;
    function Get_ReadTOCKLastTrack: Integer; safecall;
    function Get_ReadTOCLen: Integer; safecall;
    procedure ReadTOCTrack(lngTrack: Integer; out lngADR, lngTrackNumber,
      lngMins, lngSecs, lngFrames: Integer); safecall;
    function QueryCDParms(hCD, lngWhich: Integer;
      out lngNum: Integer): WordBool; safecall;
    function ModifyCDParms(hCD, lngWhich, lngValue: Integer): WordBool;
      safecall;
    function ReadCDAudioLBAOpen(hCD, lngStartFrame, lngNumFrames: Integer;
      out lngLength: Integer): Integer; safecall;
    procedure ReadCDAudioLBAClose; safecall;
    function ReadCDAudioLBARead(lngOffset: Integer): Integer; safecall;
    function GetCDDBDiskID(hCD: Integer; out lngTracks,
      lngCDDBID: Integer): Integer; safecall;
    function GetCDDBDiskIDTrackMSF(lngTrack: Integer): Integer; safecall;
    function CDDBQuery(hCD: Integer; out lngNum: Integer): Integer; safecall;
    procedure CDDBQueryRead(lngNum: Integer; out strCategory,
      strCDDBID: WideString; out blnExactMatch: WordBool; out strArtist,
      strTitle: WideString); safecall;
    procedure CDDBSetOption(lngWhat: Integer; const strValue: WideString;
      intValue: Integer); safecall;
    function CDDBGetDiskInfo(lngNum: Integer;
      out strCDDBEntry: WideString): Integer; safecall;
    function CDDBGetServerList(out lngNum: Integer): Integer; safecall;
    procedure CDDBGetServerListRead(lngNum: Integer; out strServer: WideString;
      out blnHTTP: WordBool; out lngPort: Integer; out strCGI, strNorth,
      strSouth, strLocation: WideString); safecall;
    function ReadCDAudioLBAExOpen(hCD, lngStartFrame, lngNumFrames,
      lngNumFramesOverLap: Integer; out lngLength,
      lngLengthOverlap: Integer): Integer; safecall;
    function ReadCDAudioLBAExRead(lngOffset: Integer): Integer; safecall;
    function ReadCDAudioLBAExReadOverlap(lngOffset: Integer): Integer;
      safecall;
    procedure ReadCDAudioLBAExClose; safecall;
    function ReadCDAudioLBAExOpenNext(hCD, lngStartFrame, lngNumFrames,
      lngNumFramesOverLap: Integer; blnResetLen: WordBool; out lngLength,
      lngLengthOverlap: Integer): Integer; safecall;
  end;

implementation

uses ComServ;

var typCDList: CDLIST;
    typGetCDHand: GETCDHAND;
    typCDRec: CDREC;
    typTOC: TOC;
    typTrackBuf: PTRACKBUF;
    typTrackBufEx: PTRACKBUF;
    typTrackBufExOverlap: PTRACKBUF;
    typCDDB: array[0..101] of longword;
    typQI: array[0..9] of CDDBQUERYITEM;
    typQuery: TCDDBQUERY;
    typCS: array[0..39] of CDDBSITE;
    typCSL: CDDBSITELIST;

function NewTrackBuf(NumFrames: Cardinal): PTRACKBUF;
begin
  //-- Allocate memory for numFrames Frames plus TrackBuf-Data
  GetMem(Result, (numFrames * 2352) + TRACKBUFEXTRA);

  //-- initialize TrackBuf-Data
  Result^.startFrame := 0;
  Result^.numFrames := 0;
  Result^.maxLen := numFrames * 2352;
  Result^.len := 0;
  Result^.status := 0;
  Result^.startOffset := 0;
end;

function TAKRip.Get_GetNumAdaptrers: Integer;
begin
  Result:=AKGetNumAdapters;
end;

function TAKRip.Get_GetAspiLibAspiError: Integer;
begin
  Result:=AKGetAspiLibError;
end;

function TAKRip.Get_GetAspiLibError: Integer;
begin
  Result:=AKGetAspiLibAspiError;
end;

function TAKRip.Get_GetAKRipDLLVersion: Integer;
begin
  Result:=AKGetAKRipDLLVersion;
end;

function TAKRip.GetCDId(hCD: Integer; out strCDId: WideString): Integer;
var strResult: array[0..255] of Char;
begin
  Result:=AKGetCDId(hCD,strResult,length(strResult));
  strCDId:=strResult;
end;

function TAKRip.GetCDList: Integer;
begin
  typCDList.Max:=MAXCDLIST;
  Result:=AKGetCDList(typCDList)
end;

function TAKRip.Get_GetCDListCount: Integer;
begin
  Result:=typCDList.num
end;

procedure TAKRip.GetCDListRecord(var lngCDNum: Integer; out lngHA, lngTGT,
  lngLUN, lngPAD: Integer; out strID: WideString);
begin
  lngHA:=0;
  lngTGT:=0;
  lngLUN:=0;
  lngPAD:=0;
  strID:='';
  if (typCDList.num-1>=lngCDNum) and (lngCDNum>=0) then
  begin
    lngHA:=typCDList.CD[lngCDNum].ha;
    lngTGT:=typCDList.CD[lngCDNum].tgt;
    lngLUN:=typCDList.CD[lngCDNum].lun;
    lngPAD:=typCDList.CD[lngCDNum].pad;
    strID:=typCDList.CD[lngCDNum].id;
  end;
end;

procedure TAKRip.GetCDListInfo(lngCDNum: Integer; out strVendor,
  strProductID, strRevision, strVendorSpec: WideString);
begin
  strVendor:='';
  strProductID:='';
  strRevision:='';
  strVendorSpec:='';
  if (typCDList.num-1>=lngCDNum)  and (lngCDNum>=0) then
  begin
    strVendor:=typCDList.CD[lngCDNum].info.vendor;
    strProductID:=typCDList.CD[lngCDNum].info.prodId;
    strRevision:=typCDList.CD[lngCDNum].info.rev;
    strVendorSpec:=typCDList.CD[lngCDNum].info.vendSpec;
  end;
end;

function TAKRip.GetCDHandle(lngVersion, lngHA, lngTGT, lngLUN,
  lngReadType: Integer; blnJitterCorrection: WordBool; lngNumJitter,
  lngNumOverlap: Integer): Integer;
begin
  typGetCDHand.size:=SizeOf(GETCDHAND);
  typGetCDHand.ver:=lngVersion;
  typGetCDHand.ha:=lngHA;
  typGetCDHand.tgt:=lngTGT;
  typGetCDHand.lun:=lngLUN;
  typGetCDHand.readType:=lngReadType;
  typGetCDHand.jitterCorr:=blnJitterCorrection;
  typGetCDHand.numJitter:=lngNumJitter;
  typGetCDHand.numOverlap:=lngNumOverlap;
  Result:=AKGetCDHandle(typGetCDHand);
end;

function TAKRip.CloseCDHandle(hCD: Integer): WordBool;
begin
  Result:=AKCloseCDHandle(hCD);
end;

function TAKRip.GetDriveInfo(lngHA, lngTGT, lngLUN: Integer): Integer;
begin
  Result:=AKGetDriveInfo(lngHA, lngTGT, lngLUN, typCDRec);
  typCDRec.ha:=lngHA;
  typCDRec.tgt:=lngTGT;
  typCDRec.lun:=lngLUN;
end;

procedure TAKRip.GetDriveInfoInfo(out strVendor, strProductID, strRevision,
  strVendorSpec: WideString);
begin
  strVendor:=typCDRec.info.vendor;
  strProductID:=typCDRec.info.prodId;
  strRevision:=typCDRec.info.rev;
  strVendorSpec:=typCDRec.info.vendSpec;
end;

procedure TAKRip.GetDriveInfoRecord(out lngHA, lngTGT, lngLUN,
  lngPAD: Integer; out strID: WideString);
begin
  lngHA:=typCDRec.ha;
  lngTGT:=typCDRec.tgt;
  lngLUN:=typCDRec.lun;
  lngPAD:=typCDRec.pad;
  strID:=typCDRec.id;
end;

function TAKRip.ReadTOC(hCD: Integer): Integer;
begin
  Result:=AKReadTOC(hCD,typTOC);
end;

function TAKRip.Get_ReadTOCFirstTrack: Integer;
begin
  Result:=typTOC.firstTrack;
end;

function TAKRip.Get_ReadTOCKLastTrack: Integer;
begin
  Result:=typTOC.lastTrack;
end;

function TAKRip.Get_ReadTOCLen: Integer;
begin
  Result:=typTOC.tocLen
end;

procedure TAKRip.ReadTOCTrack(lngTrack: Integer; out lngADR,
  lngTrackNumber, lngMins, lngSecs, lngFrames: Integer);
begin
  lngADR:=typTOC.tracks[lngTrack].ADR;
  lngTrackNumber:=typTOC.tracks[lngTrack].trackNumber;
  lngMins:=typTOC.tracks[lngTrack].addr[1];
  lngSecs:=typTOC.tracks[lngTrack].addr[2];
  lngFrames:=typTOC.tracks[lngTrack].addr[3];
end;

function TAKRip.QueryCDParms(hCD, lngWhich: Integer;
  out lngNum: Integer): WordBool;
var intResult: Longword;
begin
  Result:=AKQueryCDParms(hCD,lngWhich,intResult);
  lngNum:=intResult;
end;

function TAKRip.ModifyCDParms(hCD, lngWhich, lngValue: Integer): WordBool;
begin
  Result:=AKModifyCDParms(hCD,lngWhich,lngValue);
end;

function TAKRip.ReadCDAudioLBAOpen(hCD, lngStartFrame,
  lngNumFrames: Integer; out lngLength: Integer): Integer;
begin
  typTrackBuf:=NewTrackBuf(lngNumFrames);
  typTrackBuf^.startFrame:=lngStartFrame;
  typTrackBuf^.numFrames:=lngNumFrames;
  Result:=AKReadCDAudioLBA(hCD,typTrackBuf);
  lngLength:=typTrackBuf^.len;
end;

procedure TAKRip.ReadCDAudioLBAClose;
begin
  FreeMem(typTrackBuf);
end;

function TAKRip.ReadCDAudioLBARead(lngOffset: Integer): Integer;
var Buffer: array [0..1] of char;
begin
  StrLCopy(Buffer, PChar(Addr(typTrackBuf^.buf)) + typTrackBuf^.startOffset+lngOffset,1);
  Result:=Ord(Buffer[0]);
end;

function TAKRip.GetCDDBDiskID(hCD: Integer; out lngTracks,
  lngCDDBID: Integer): Integer;
begin
  Result:=AKGetCDDBDiskID(hCD,typCDDB,102);
  lngCDDBID:=typCDDB[0];
  lngTracks:=typCDDB[1];
end;

function TAKRip.GetCDDBDiskIDTrackMSF(lngTrack: Integer): Integer;
begin
  Result:=typCDDB[2+lngTrack];
end;

function TAKRip.CDDBQuery(hCD: Integer; out lngNum: Integer): Integer;
begin
  FillChar(typQI, SizeOf(CDDBQUERYITEM) * 10, 0);
  typQuery.num := 10;
  typQuery.q := PCDDBQUERYITEM(Addr(typQI));
  Result:=AKCDDBQuery(hCD, typQuery);
  lngNum:=typQuery.num;
end;

procedure TAKRip.CDDBQueryRead(lngNum: Integer; out strCategory,
  strCDDBID: WideString; out blnExactMatch: WordBool; out strArtist,
  strTitle: WideString);
begin
  strCategory:=typQI[lngNum].categ;
  strCDDBID:=typQI[lngNum].cddbId;
  blnExactMatch:=typQI[lngNum].bExact;
  strArtist:=typQI[lngNum].artist;
  strTitle:=typQI[lngNum].title;
end;

procedure TAKRip.CDDBSetOption(lngWhat: Integer;
  const strValue: WideString; intValue: Integer);
begin
  AKCDDBSetOption(lngWhat,PChar(strValue),intValue);
end;

function TAKRip.CDDBGetDiskInfo(lngNum: Integer;
  out strCDDBEntry: WideString): Integer;
var strEntry: string;
begin
  SetLength(strEntry, 32000);
  Result:=AKCDDBGetDiskInfo(typQI[lngNum], PChar(strEntry), 32000);
  strCDDBEntry:=strEntry;
end;

function TAKRip.CDDBGetServerList(out lngNum: Integer): Integer;
begin
  FillChar(typCS, SizeOf(CDDBSITE) * 40, 0);
  typCSL.num := 40;
  typCSL.s := PCDDBSITE(Addr(typCS));
  Result:=AKCDDBGetServerList(typCSL);
  lngNum:=typCSL.num;
end;

procedure TAKRip.CDDBGetServerListRead(lngNum: Integer;
  out strServer: WideString; out blnHTTP: WordBool; out lngPort: Integer;
  out strCGI, strNorth, strSouth, strLocation: WideString);
begin
  strServer:=typCS[lngNum].szServer;
  blnHTTP:=typCS[lngNum].bHTTP;
  lngPort:=typCS[lngNum].iPort;
  strCGI:=typCS[lngNum].szCGI;
  strNorth:=typCS[lngNum].szNorth;
  strSouth:=typCS[lngNum].szSouth;
  strLocation:=typCS[lngNum].szLocation;
end;

function TAKRip.ReadCDAudioLBAExOpen(hCD, lngStartFrame, lngNumFrames,
  lngNumFramesOverLap: Integer; out lngLength,
  lngLengthOverlap: Integer): Integer;
begin
  typTrackBufEx:=NewTrackBuf(lngNumFrames);
  typTrackBufEx^.startFrame:=lngStartFrame;
  typTrackBufEx^.numFrames:=lngNumFrames;
  typTrackBufExOverlap:=NewTrackBuf(lngNumFramesOverLap);
  typTrackBufExOverlap^.startFrame:=0;
  typTrackBufExOverlap^.numFrames:=0;
  typTrackBufExOverlap^.len:=0;
  Result:=AKReadCDAudioLBAEx(hCD,typTrackBufEx,typTrackBufExOverlap);
  lngLength:=typTrackBufEx^.len;
  lngLengthOverlap:=typTrackBufExOverlap^.len;
end;

function TAKRip.ReadCDAudioLBAExOpenNext(hCD, lngStartFrame, lngNumFrames,
  lngNumFramesOverLap: Integer; blnResetLen: WordBool; out lngLength,
  lngLengthOverlap: Integer): Integer;
begin
  typTrackBufEx^.startFrame:=lngStartFrame;
  typTrackBufEx^.numFrames:=lngNumFrames;
  if blnResetLen=True Then typTrackBufExOverlap^.len:=0;
  Result:=AKReadCDAudioLBAEx(hCD,typTrackBufEx,typTrackBufExOverlap);
  lngLength:=typTrackBufEx^.len;
  lngLengthOverlap:=typTrackBufExOverlap^.len;
end;

function TAKRip.ReadCDAudioLBAExRead(lngOffset: Integer): Integer;
var Buffer: array [0..1] of char;
begin
  StrLCopy(Buffer, PChar(Addr(typTrackBufEx^.buf)) + typTrackBufEx^.startOffset+lngOffset,1);
  Result:=Ord(Buffer[0]);
end;

function TAKRip.ReadCDAudioLBAExReadOverlap(lngOffset: Integer): Integer;
var Buffer: array [0..1] of char;
begin
  StrLCopy(Buffer, PChar(Addr(typTrackBufExOverLap^.buf)) + typTrackBufExOverLap^.startOffset+lngOffset,1);
  Result:=Ord(Buffer[0]);
end;

procedure TAKRip.ReadCDAudioLBAExClose;
begin
  FreeMem(typTrackBufEx);
  FreeMem(typTrackBufExOverlap);
end;

initialization
  TAutoObjectFactory.Create(ComServer, TAKRip, Class_AKRip,
    ciMultiInstance, tmApartment);
end.
